/* AMX Mod script. 
* 
* (c) Copyright 2002, OLO 
* This file is provided as is (no warranties). 
* 
*/ 

#include <amxmod> 

/* cmd for server and admins (with flag "n"): 
*  amx_restrict < menu > [ keys ] 
*  no keys clears restriction from weapon menu 
*  examples: 
*  block whole pistol menu 
*  amx_restrict buy 1 
* 
*  block sg552 and aug 
*  amx_restrict rifle 24 
*/ 

new restricted[7] 
new menus[7][] = {"buy","pistol","shotgun","sub","rifle","machine","item"} 

public menu_buy(id,key) 
    return do_sorry(id,restricted[0],(1<<key)) ? PLUGIN_HANDLED : PLUGIN_CONTINUE 

public menu_pistol(id,key) 
    return do_sorry(id,restricted[1],(1<<key)) ? PLUGIN_HANDLED : PLUGIN_CONTINUE 

public menu_shotgun(id,key) 
    return do_sorry(id,restricted[2],(1<<key)) ? PLUGIN_HANDLED : PLUGIN_CONTINUE 

public menu_sub(id,key) 
    return do_sorry(id,restricted[3],(1<<key)) ? PLUGIN_HANDLED : PLUGIN_CONTINUE 

public menu_rifle(id,key) 
    return do_sorry(id,restricted[4],(1<<key)) ? PLUGIN_HANDLED : PLUGIN_CONTINUE 

public menu_machine(id,key) 
    return do_sorry(id,restricted[5],(1<<key)) ? PLUGIN_HANDLED : PLUGIN_CONTINUE 

public menu_item(id,key) 
    return do_sorry(id,restricted[6],(1<<key)) ? PLUGIN_HANDLED : PLUGIN_CONTINUE 

do_sorry(id,rest,bit){ 
    if (!(rest & bit))return 0 
    engclient_cmd(id,"menuselect","10") 
    client_print(id,print_center,"[AMX] This position is restricted...") 
    return 1 
} 

do_setting(arg1[]) { 
    new arg2[32], a, d = 0 
    read_argv(1,arg1,32) 
    for(a=0; a<7; ++a) 
        if(equal(arg1,menus[a])) 
            break 
    if (a==7) return 0 
    if (read_argc()>2){ 
        read_argv(2,arg2,32) 
        while(arg2[d]){ 
            restricted[a] |= (1<<(((arg2[d]=='0')?10:arg2[d])-'1')) 
            d++ 
        } 
        return 1 
    } 
    restricted[a]=0 
    return 2 
} 

public admin_restrict(id){ 
    if (!(get_user_flags(id)&ADMIN_LEVEL_B)){ 
        client_print(id,print_console,"[AMX] You have no access to that command") 
        return PLUGIN_HANDLED 
    } 
    if (read_argc() < 2) { 
        client_print(id,print_console,"[AMX] Usage:  amx_restrict < menu > [ keys ]") 
        return PLUGIN_HANDLED 
    } 
    new arg1[32] 
    switch(do_setting(arg1)){ 
        case 1:    client_print(id,print_console,"[AMX] Proper restriction for menu ^"%s^" set",arg1) 
        case 2:    client_print(id,print_console,"[AMX] Restriction removed from menu ^"%s^"",arg1) 
        default: client_print(id,print_console,"[AMX] Menus: ^"buy^",^"pistol^",^"shotgun^",^"sub^",^"rifle^",^"machine^",^"item^"") 
    } 
    return PLUGIN_HANDLED 
} 

public srv_restrict(){ 
    if (read_argc() < 2) { 
        server_print("[AMX] Usage:  amx_restrict < menu > [ keys ]") 
        return PLUGIN_HANDLED 
    } 
    new arg1[32] 
    switch(do_setting(arg1)){ 
        case 1:    server_print("[AMX] Proper restriction for menu ^"%s^" set",arg1) 
        case 2:    server_print("[AMX] Restriction removed from menu ^"%s^"",arg1) 
        default:{ 
        server_print("[AMX] Usage:  amx_restrict < menu > [ keys ]") 
        server_print("[AMX] Menus: ^"buy^",^"pistol^",^"shotgun^",^"sub^",^"rifle^",^"machine^",^"item^"") 
        } 
    } 
    return PLUGIN_HANDLED 
} 

public plugin_init(){ 
    register_plugin("Weapon Restriction","0.5","default") 
    /* text menu */ 
    register_menucmd(register_menuid("#Buy"),1023,"menu_buy") 
    register_menucmd(register_menuid("BuyPistol"),1023,"menu_pistol") 
    register_menucmd(register_menuid("BuyShotgun"),1023,"menu_shotgun") 
    register_menucmd(register_menuid("BuySub"),1023,"menu_sub") 
    register_menucmd(register_menuid("BuyRifle"),1023,"menu_rifle") 
    register_menucmd(register_menuid("BuyMachine"),1023,"menu_machine") 
    register_menucmd(register_menuid("BuyItem"),1023,"menu_item") 
    /* vgui menu */ 
    register_menucmd(-28,1023,"menu_buy") 
    register_menucmd(-29,1023,"menu_pistol") 
    register_menucmd(-30,1023,"menu_shotgun") 
    register_menucmd(-32,1023,"menu_sub") 
    register_menucmd(-31,1023,"menu_rifle") 
    register_menucmd(-33,1023,"menu_machine") 
    register_menucmd(-34,1023,"menu_item") 
    register_clcmd("amx_restrict","admin_restrict",ADMIN_LEVEL_B,"amx_restrict < menu > [ keys ]") 
    register_srvcmd("amx_restrict","srv_restrict") 
    return PLUGIN_CONTINUE  
} 
